TUTORIAL DE SUPERCOLLIDER 3 - PARTE 10
Rodrigo F. Cadiz, basado en apuntes de Gary S. Kendall
Northwestern University

(
   Server.internal.boot;
   Server.default = Server.internal;
   s = Server.default;
)

Patterns


Making Music with Patterns

Here is an example that uses a Pattern to create two instances of
the random melody stream.

(
	SynthDef( "SPE2", { arg i_out=0, i_dur=1, freq;
		var out;
		out = RLPF.ar(
			LFSaw.ar( freq ),
			LFNoise1.kr(1, 36, 110).midicps,
			0.1
		) * EnvGen.kr( Env.perc, levelScale: 0.3, 
							timeScale: i_dur, doneAction: 2 );
		4.do({ out = AllpassN.ar(out, 0.05, [0.05.rand, 0.05.rand], 4) });
		Out.ar( i_out, out );
	}).send(s);
)
(
// streams as a sequence of pitches
	var pattern, streams, dur, durDiff;
	dur = 1/7;
	durDiff = 3;
	pattern = Prout.new({
		loop({
			if (0.5.coin, {
				#[ 24,31,36,43,48,55 ].do({ arg fifth; fifth.yield });
			});
			rrand(2,5).do({
				// varying arpeggio
				60.yield;
				#[63,65].choose.yield;
				67.yield;
				#[70,72,74].choose.yield;
			});
			// random high melody
			rrand(3,9).do({  #[74,75,77,79,81].choose.yield });
		});
	});
	streams = [  // Stream.at(0)  combines Prout's output with Pfunc transposing notes randomly
		(pattern - Pfunc.new({ #[12, 7, 7, 0].choose })).midicps.asStream, // 0 in array
		pattern.midicps.asStream // 1 in array
	];
	Routine({
		loop({
			// Do this
			Synth( "SPE2", [ \freq, streams.at(0).next, \i_dur, dur * durDiff  ] );
			durDiff.do({  // then do this durDiff times
				Synth( "SPE2", [ \freq, streams.at(1).next, \i_dur, dur  ] );
				dur.wait;
			});
		})
	}).play
)