TUTORIAL DE SUPERCOLLIDER 3 - PARTE 8
Rodrigo F. Cadiz, basado en apuntes de Gary S. Kendall
Northwestern University

Mas FM

Detuning by a small factor.

({
	var fundFreq, detune, peakFMI, carrierFreq, modulatorFreq, env1, env2, amp, instFreqDv, instFreq;
	fundFreq = 440.0;	// fundamental frequency
	detune = 0.5;
	c = 1; 
	m = 1;
	peakFMI = 3;
	carrierFreq = c * fundFreq;				// C:M ratio determines the carrier and
	modulatorFreq = m * fundFreq + detune;     //  the modulator frequency + detuning
	
	env1 = Env.new([0,5.0,3.75,3.0,0]/5,[0.15,0.15,2,0.15],'linear');  // amp Env
	amp = EnvGen.kr(env1);
	env2 = Env.new([2 * peakFMI, peakFMI, peakFMI],[0.3,0.45],'linear');   // FMI Env
	instFreqDv = modulatorFreq * EnvGen.kr(env2);
	
	instFreq = SinOsc.ar(modulatorFreq,0,instFreqDv,carrierFreq);
	SinOsc.ar(instFreq,0,amp);	
}.play)


Multiple-Carrier FM can often produce tones with a vowel-like quality.

({
	var fundFreq, c1, c2, peakFMI, carrierFreq1, carrierFreq2, modulatorFreq, env1, env2; 
	var amp, freqDv, instFreqDv;
	fundFreq = 440.0;
	c1 = 1; 
	c2 = 6; 
	m = 1;
	peakFMI = 0.5;
	carrierFreq1 = c1 * fundFreq;  // C1 : C2 : M ratio
	carrierFreq2 = c2 * fundFreq;		
	modulatorFreq = m * fundFreq;	
	
	env1 = Env.new([0,5.0,3.75,3.0,0]/5,[0.15,0.15,2.0,0.15],'linear');
	amp = 0.3 * EnvGen.kr(env1);
	env2 = Env.new([0.5 * peakFMI, peakFMI, 0.7 * peakFMI],[0.3,0.45],'linear');
	freqDv = modulatorFreq * EnvGen.kr(env2);
	
	instFreqDv = SinOsc.ar(modulatorFreq,0,freqDv);
	SinOsc.ar(instFreqDv+carrierFreq1,0,amp) + 		// Two carriers are being modulated
	SinOsc.ar(instFreqDv+carrierFreq2,0,amp);	
}.play)


Multiple-Modulator FM can often produce tones with a smoother quality than raw FM.

({
	var fundFreq, m1, m2, peakFMI1, peakFMI2, carrierFreq, modulatorFreq1, modulatorFreq2;
	var env1, env2, amp, instFMI, instFreqDv1, instFreqDv2, instFreq;
	fundFreq = 440.0;	
	c = 1; 
	m1 = 1; 
	m2 = 4;
	peakFMI1 = 1;
	peakFMI2 = 0.4;
	carrierFreq = c * fundFreq + 0.5;  // C : M1 : M2 ratio
	modulatorFreq1 = m1 * fundFreq;	
	modulatorFreq2 = m2 * fundFreq;	
	
	env1 = Env.new([0,5.0,3.75,3.0,0]/5,[0.15,0.15,2.0,0.15],'linear');
	amp = 0.5 * EnvGen.kr(env1);
	env2 = Env.new([2.0, 1.0, 0.6],[0.3,0.45],'linear');
	instFMI = EnvGen.kr(env2);				                         //  One FMI envelope
	
	instFreqDv1 = peakFMI1 * modulatorFreq1 * instFMI;  //     with individual 
	instFreqDv2 = peakFMI2 * modulatorFreq2 * instFMI; // instantaneous frequency deviations
	
	instFreq = SinOsc.ar(modulatorFreq1,0,instFreqDv1) +  // Two modulating oscillators
				SinOsc.ar(modulatorFreq2,0,instFreqDv2) +
				carrierFreq;
	
	SinOsc.ar(instFreq,0,amp);   // One carrier
}.play)

({
	// Try different values for fundFreq
	var fundFreq = 1760;
	var duration, detune, peakFMI, vibRate, vibDepth;
	var carrierFreq, modulatorFreq, octave,attackTm, sustainTm, releaseTm;
	var env1, env2, env3, amp, instFreqDv, instVib, instFreq;
	
	// parameters
	duration = 2.0;
	detune = 0.5;
	c = 2; m = 1;
	peakFMI = 3.0;
	vibRate = 4.0;
	vibDepth = 0.006;
	
	//  calculate actual carrier and modulator frequencies
	carrierFreq = c * fundFreq;	
	modulatorFreq = m * fundFreq + detune.rand;  // random variations
	
	// modifications based on fundamental frequency
	octave = fundFreq.cpsoct;	// determine the octave
	post('octave = ');octave.postln;
	peakFMI = peakFMI * 20.0 / (octave*octave);  // peakFM decreases in higher octaves
	vibRate = vibRate * octave / 5.0;  // vibRate increases in higher octaves
	vibDepth = vibDepth * 5.0 / octave;
	postln('peakFMI/vibRate/vibDepth = '); peakFMI.postln;vibRate.postln;vibDepth.postln;
	// attack and release times based on fundamental frequency
	attackTm = 0.4 * 4.0 / fundFreq.cpsoct;   // attackTM decreases in higher octaves
	releaseTm = 1.5* attackTm;
	sustainTm = duration - attackTm - releaseTm;
	if (releaseTm > sustainTm, {releaseTm = sustainTm = (duration - attackTm)/2});

	//  amplitude envelope
	env1 = Env.new([0,1.0,0.75,0],[attackTm,sustainTm,releaseTm],'linear');
	amp = EnvGen.kr(env1);
	//  FMI envelope
	env2 = Env.new([2*peakFMI, peakFMI, 0.8*peakFMI, 
				0.5*peakFMI],[attackTm,sustainTm,releaseTm],'linear');
	instFreqDv = modulatorFreq * EnvGen.kr(env2);
	//  vibrato envelope
	env3 = Env.new([0,vibDepth,0.8*vibDepth,0],[attackTm,sustainTm,releaseTm],'linear');
	instVib = 1 + SinOsc.kr(vibRate + 3.0.rand,0,EnvGen.kr(env3));
	
	instFreq = SinOsc.ar(instVib*modulatorFreq,0,instFreqDv,instVib*carrierFreq);
	SinOsc.ar(instFreq,0,amp);	
}.play;)
More complete instrument design Version #1:

Vibrato added with its own envelope.

({
		var fundFreq, duration, detune, peakFMI, vibRate, vibDepth;
		var carrierFreq, modulatorFreq, attackTm, sustainTm, releaseTm;
		var env1, env2, env3, amp, instFreqDv, instVib, instFreq;
		
		// parameters
		fundFreq = 880.0;
		duration = 2.0;
		detune = 0.5;
		c = 2; m = 1;
		peakFMI = 3;
		vibRate = 5.0;  // vibrator rate
		vibDepth = 0.008;  // vibrato depth as a fraction of fundament frequency

		//  calculate actual carrier and modulator frequencies
		carrierFreq = c * fundFreq;	
		modulatorFreq = m * fundFreq + detune.rand;  // random detuning
		post('carrier frequency = '); carrierFreq.postln;
		post('modulator frequency = '); modulatorFreq.postln;

		// attack and release times
		attackTm = 0.3;
		releaseTm = 2.0* attackTm;
		sustainTm = duration - attackTm - releaseTm;
		if (releaseTm > sustainTm, {releaseTm = sustainTm = (duration - attackTm)/2});
		post('attack time = '); attackTm.postln;
		post('sustain time = '); sustainTm.postln;
		post('release time = '); releaseTm.postln;

		//  amplitude envelope
		env1 = Env.new([0,1.0,0.75,0],[attackTm,sustainTm,releaseTm],'linear');
		amp = EnvGen.kr(env1);
		//  FMI envelope
		env2 = Env.new([2*peakFMI, peakFMI, 0.8*peakFMI, 
					0.5*peakFMI],[attackTm,sustainTm,releaseTm],'linear');
		instFreqDv = modulatorFreq * EnvGen.kr(env2);
		//  vibrato envelope
		env3 = Env.new([0,vibDepth,0.8*vibDepth,0],[attackTm,sustainTm,releaseTm],'linear');
		instVib = 1 + SinOsc.kr(vibRate + 3.0.rand,0, EnvGen.kr(env3)); // random variations too
		
		instFreq = SinOsc.ar(instVib*modulatorFreq, 0, instFreqDv, instVib*carrierFreq); 
					// vibrator affects both carrier and modulators
		SinOsc.ar(instFreq,0,amp);	
}.play;)


More complete instrument design Version #2:

Parameters are made sensitive to the octave of the fundamental.

({
	// Try different values for fundFreq
	var fundFreq = 1760;
	var duration, detune, peakFMI, vibRate, vibDepth;
	var carrierFreq, modulatorFreq, octave,attackTm, sustainTm, releaseTm;
	var env1, env2, env3, amp, instFreqDv, instVib, instFreq;
	
	// parameters
	duration = 2.0;
	detune = 0.5;
	c = 2; m = 1;
	peakFMI = 3.0;
	vibRate = 4.0;
	vibDepth = 0.006;
	
	//  calculate actual carrier and modulator frequencies
	carrierFreq = c * fundFreq;	
	modulatorFreq = m * fundFreq + detune.rand;  // random variations
	
	// modifications based on fundamental frequency
	octave = fundFreq.cpsoct;	// determine the octave
	post('octave = ');octave.postln;
	peakFMI = peakFMI * 20.0 / (octave*octave);  // peakFM decreases in higher octaves
	vibRate = vibRate * octave / 5.0;  // vibRate increases in higher octaves
	vibDepth = vibDepth * 5.0 / octave;
	postln('peakFMI/vibRate/vibDepth = '); peakFMI.postln;vibRate.postln;vibDepth.postln;
	// attack and release times based on fundamental frequency
	attackTm = 0.4 * 4.0 / fundFreq.cpsoct;   // attackTM decreases in higher octaves
	releaseTm = 1.5* attackTm;
	sustainTm = duration - attackTm - releaseTm;
	if (releaseTm > sustainTm, {releaseTm = sustainTm = (duration - attackTm)/2});

	//  amplitud({
	// Try different values for fundFreq
	var fundFreq = 1760;
	var duration, detune, peakFMI, vibRate, vibDepth;
	var carrierFreq, modulatorFreq, octave,attackTm, sustainTm, releaseTm;
	var env1, env2, env3, amp, instFreqDv, instVib, instFreq;
	
	// parameters
	duration = 2.0;
	detune = 0.5;
	c = 2; m = 1;
	peakFMI = 3.0;
	vibRate = 4.0;
	vibDepth = 0.006;
	
	//  calculate actual carrier and modulator frequencies
	carrierFreq = c * fundFreq;	
	modulatorFreq = m * fundFreq + detune.rand;  // random variations
	
	// modifications based on fundamental frequency
	octave = fundFreq.cpsoct;	// determine the octave
	post('octave = ');octave.postln;
	peakFMI = pe({
	// Try different values for fundFreq
	var fundFreq = 1760;
	var duration, detune, peakFMI, vibRate, vibDepth;
	var carrierFreq, modulatorFreq, octave,attackTm, sustainTm, releaseTm;
	var env1, env2, env3, amp, instFreqDv, instVib, instFreq;
	
	// parameters
	duration = 2.0;
	detune = 0.5;
	c = 2; m = 1;
	peakFMI = 3.0;
	vibRate = 4.0;
	vibDepth = 0.006;
	
	//  calculate actual carrier and modulator frequencies
	carrierFreq = c * fundFreq;	
	modulatorFreq = m * fundFreq + detune.rand;  // random variations
	
	// modifications based on fundamental frequency
	octave = fundFreq.cpsoct;	// determine the octave
	post('octave = ');octave.postln;
	peakFMI = peakFMI * 20.0 / (octave*octave);  // peakFM decreases in higher octaves
	vibRate = vibRate * octave / 5.0;  // vibRate increases in higher octaves
	vibDepth = vibDepth * 5.0 / octave;
	postln('peakFMI/vibRate/vibDepth = '); peakFMI.postln;vibRate.postln;vibDepth.postln;
	// attack and release times based on fundamental frequency
	attackTm = 0.4 * 4.0 / fundFreq.cpsoct;   // attackTM decreases in higher octaves
	releaseTm = 1.5* attackTm;
	sustainTm = duration - attackTm - releaseTm;
	if (releaseTm > sustainTm, {releaseTm = sustainTm = (duration - attackTm)/2});

	//  amplitude envelope
	env1 = Env.new([0,1.0,0.75,0],[attackTm,sustainTm,releaseTm],'linear');
	amp = EnvGen.kr(env1);
	//  FMI envelope
	env2 = Env.new([2*peakFMI, peakFMI, 0.8*peakFMI, 
				0.5*peakFMI],[attackTm,sustainTm,releaseTm],'linear');
	instFreqDv = modulatorFreq * EnvGen.kr(env2);
	//  vibrato envelope
	env3 = Env.new([0,vibDepth,0.8*vibDepth,0],[attackTm,sustainTm,releaseTm],'linear');
	instVib = 1 + SinOsc.kr(vibRate + 3.0.rand,0,EnvGen.kr(env3));
	
	instFreq = SinOsc.ar(instVib*modulatorFreq,0,instFreqDv,instVib*carrierFreq);
	SinOsc.ar(instFreq,0,amp);	
}.play;)akFMI * 20.0 / (octave*octave);  // peakFM decreases in higher octaves
	vibRate = vibRate * octave / 5.0;  // vibRate increases in higher octaves
	vibDepth = vibDepth * 5.0 / octave;
	postln('peakFMI/vibRate/vibDepth = '); peakFMI.postln;vibRate.postln;vibDepth.postln;
	// attack and release times based on fundamental frequency
	attackTm = 0.4 * 4.0 / fundFreq.cpsoct;   // attackTM decreases in higher octaves
	releaseTm = 1.5* attackTm;
	sustainTm = duration - attackTm - releaseTm;
	if (releaseTm > sustainTm, {releaseTm = sustainTm = (duration - attackTm)/2});

	//  amplitude envelope
	env1 = Env.new([0,1.0,0.75,0],[attackTm,sustainTm,releaseTm],'linear');
	amp = EnvGen.kr(env1);
	//  FMI envelope
	env2 = Env.new([2*peakFMI, peakFMI, 0.8*peakFMI, 
				0.5*peakFMI],[attackTm,sustainTm,releaseTm],'linear');
	instFreqDv = modulatorFreq * EnvGen.kr(env2);
	//  vibrato envelope
	env3 = Env.new([0,vibDepth,0.8*vibDepth,0],[attackTm,sustainTm,releaseTm],'linear');
	instVib = 1 + SinOsc.kr(vibRate + 3.0.rand,0,EnvGen.kr(env3));
	
	instFreq = SinOsc.ar(instVib*modulatorFreq,0,instFreqDv,instVib*carrierFreq);
	SinOsc.ar(instFreq,0,amp);	
}.play;)e envelope
	env1 = Env.new([0,1.0,0.75,0],[attackTm,sustainTm,releaseTm],'linear');
	amp = EnvGen.kr(env1);
	//  FMI envelope
	env2 = Env.new([2*peakFMI, peakFMI, 0.8*peakFMI, 
				0.5*peakFMI],[attackTm,sustainTm,releaseTm],'linear');
	instFreqDv = modulatorFreq * EnvGen.kr(env2);
	//  vibrato envelope
	env3 = Env.new([0,vibDepth,0.8*vibDepth,0],[attackTm,sustainTm,releaseTm],'linear');
	instVib = 1 + SinOsc.kr(vibRate + 3.0.rand,0,EnvGen.kr(env3));
	
	instFreq = SinOsc.ar(instVib*modulatorFreq,0,instFreqDv,instVib*carrierFreq);
	SinOsc.ar(instFreq,0,amp);	
}.play;)


